<?php

declare(strict_types=1);

namespace Dedi\SyliusQuotePlugin\Specification\OrderItem;

use Dedi\SyliusQuotePlugin\Entity\OrderInterface;
use Dedi\SyliusQuotePlugin\Entity\OrderItemInterface;
use Dedi\SyliusQuotePlugin\Specification\Order\IsQuoteSpecification;

class IsQuoteItemSpecification
{
    private IsQuoteSpecification $isQuoteSpecification;

    public function __construct(IsQuoteSpecification $isQuoteSpecification)
    {
        $this->isQuoteSpecification = $isQuoteSpecification;
    }

    public function isSatisfiedBy(OrderItemInterface $orderItem): bool
    {
        /** @var ?OrderInterface $order */
        $order = $orderItem->getOrder();

        if (null === $order) {
            return false;
        }

        return $this->isQuoteSpecification->isSatisfiedBy($order);
    }
}
